' /////////////////////////////////////
' // Ironsword: Skull and Bones
' // version 1.0 (06.02.06)
' // by Eikon (eikon@carolina.rr.com)
' // www.Eiksoft.com
' /////////////////////////////////////
Framework BRL.Max2D 
Import BRL.D3D7Max2D
Import PUB.Mersenne
Import BRL.Retro
Import BRL.PNGLoader
Import BRL.Audio
Import BRL.FreeAudioAudio
Import BRL.WAVLoader
Import BRL.OGGLoader
Import BRL.Event 
Import BRL.EventQueue
Import "gfx/icon.o"

Extern "win32"
	Function FindWindow(lpClassName$z, lpWindowName$z) = "FindWindowA@8"
	Function GetDesktopWindow()
    Function GetTickCount()
	Function GetWindowRect(hWnd, lpRect:Byte Ptr)
	Function SetWindowPos(hWnd, after, x, y, w, h, flags)
	Function IsZoomed%(hwnd%)
End Extern

Type lpRECT
	Field l, t, r, b
End Type

Global bFilter, bTitle = True, myhWnd, vidMode, ringX = 40, ringC, bSkull, score = 1000
Global gameOver, correct, wrong
Global MyMilliSecs, LastMilliSecs = GetTickCount()

Global imgTitle:TImage, imgGlare:TImage, imgPlay:TImage, imgRing:TImage, imgSkull:TImage
Global imgCups:TImage, imgFont:TImage, imgEnd:TImage

LoadImages BFilter

Global Channel:TChannel = AllocChannel()
Global musTitle:TSound = LoadSound("sfx/title.ogg", 1)
Global musSong1:TSound = LoadSound("sfx/song1.ogg", 1)
Global musSong2:TSound = LoadSound("sfx/end.ogg", 1)
Global sfxHit:TSound = LoadSound("sfx/hit.wav")
Global sfxDrop:TSound = LoadSound("sfx/drop.wav")
Global sfxWon:TSound = LoadSound("sfx/won.wav")
Global sfxOut:TSound = LoadSound("sfx/out.wav")

AppTitle = "Ironsword: Skull and Bones"
SetGraphicsDriver D3D7Max2DDriver()
Graphics 640, 480, 0, 60
SeedRand GetTickCount()  
WindowMode

Channel = PlaySound(musTitle)

Global o:Obj, objList:TList = CreateList()
    
Type Obj    
    Field X, Y#, F, T, ID, D, R, G#, S, S2
       
    Function Create:Obj(X, Y, R, ID)
        o:Obj = New Obj
        o.X = X; o.Y = Y
        o.ID = ID 
        
        Select ID
            Case 1
            o.T = MilliSecs()
            o.D = 1
            o.R = R
            
            Case 2
            o.G = 3
            o.D = -1
            o.T = RandRange(0, 1)
            
        End Select
        
        Return o
    End Function

    Method Render()
        Local Del = False
        
        Select ID
			Case 1 ' Glare
            DrawImage imgGlare, X, Y, F
        
            If MilliSecs() >= T + 150 Then
                If D = 1 Then
                    If F < 2 Then F:+1 Else D = 0
                Else
                    If F > 0 Then F:-1 Else Del = True
                EndIf
                T = MilliSecs()
            EndIf
        
       		Case 2 ' Skull
            SetRotation R
            DrawImage imgSkull, X, Int(Y)
            SetRotation 0
            If T = 0 Then R:+5 Else R:-5
            
            If o.D = 0 Then o.X = o.X - 1 ElseIf o.D = 1 Then o.X = o.X + 1
            
            If Y >= 105 And F = 0 Then ' Bump 1
                D = RandRange(0, 1)
                F = 1
                G = -3
                S = D                
                PlaySound sfxHit
            ElseIf Y >= 150 And F = 1 Then ' Bump 2
                F = 2
                G = -3
                PlaySound sfxHit
            ElseIf Y >= 220 And F = 2 Then ' Bump 3
                D = RandRange(0, 1)
                G = -3
                F = 3
                S2 = D
                PlaySound sfxHit
            EndIf
            
            If G < 3 Then G:+.15 Else G = 3
            
            If Y < 320 Then 
                Y:+G 
            Else 
                Del = True
                bSkull = False

                If S = 0 And S2 = 0 Then tmpC = 0
                If S = 0 And S2 = 1 Then tmpC = 1
                If S = 1 And S2 = 0 Then tmpC = 2
                If S = 1 And S2 = 1 Then tmpC = 3

                If tmpC = ringC Then ' Hit
                    score:+390; correct:+1
                    PlaySound sfxWon

                Else                 ' Miss
                    wrong:+1

                    If score = 0 Then 
						gameOver = True
						If ChannelPlaying(Channel) = True Then 
			                StopChannel Channel
            			    Channel = PlaySound(musSong2)
			            EndIf
			
						For o:Obj = EachIn ObjList; objList.Remove o; Next
						Del = False
					EndIf
					
					PlaySound sfxOut
                EndIf

            EndIf
       	End Select
        
        If Del = True Then objList.Remove o
    
    End Method
    
End Type

Repeat
SetOrigin 64, 16

If AppSuspended() = True Then Repeat; Delay 10; Until AppSuspended() = False ' Suspend
    
If bTitle = True Then ' Title 
    RenderTitle

ElseIf bTitle = False And gameOver = False Then ' Game
    SetScale 2, 2
    DrawImage imgPlay, 0, 0
       
    For o:Obj = EachIn objList; o.Render; Next
    
    DrawImage imgCups, 18, 294
    DrawImage imgRing, ringX, 280
    bmpText String(score), 104, 412
    
    If KeyHit(KEY_LEFT) And bSkull = False Then
        If ringC > 0 Then ringC:-1 Else ringC = 3
    EndIf
    
    If KeyHit(KEY_RIGHT) And bSkull = False Then
        If ringC < 3 Then ringC:+1 Else ringC = 0
    EndIf
    
    If KeyHit(KEY_ENTER) Or KeyHit(KEY_SPACE) And bSkull = False Then
        If score >= 100 Then score:-100 Else score = 0
        PlaySound sfxDrop
        objList.AddLast obj.Create(258, 90, 0, 2)
        bSkull = True
    EndIf
    
    Select ringC
        Case 0
        ringX = 40
        
        Case 1 
        ringX = 40 + 128
        
        Case 2
        ringX = 264
        
        Case 3
        ringX = 264 + 128
        
    End Select

ElseIf gameOver = True ' Game Over

    SetScale 2, 2
    DrawImage imgEnd, 0, 0
    
    bmpText String(correct), 308, 90
    bmpText String(wrong), 308, 150
    bmpText String(score), 308, 210
	If correct + wrong > 0 Then
		tmpPer = Int(Float(Float(correct) / Float(correct + wrong)) * 100)
	Else
		tmpPer = 0
	EndIf
    bmpText String(tmpPer) + "%", 308, 270

	For o:Obj = EachIn objList; o.Render; Next

	If RandRange(1, 100) = 50 Then ' Glare
	    objList.AddLast obj.Create(RandRange(200, 312), RandRange(342, 390), 0, 1)
	EndIf
	
EndIf
	
HandleMouse
HandleVideo

Flip; Cls
Until AppTerminate() = True

Function LoadImages(Filter)

imgTitle = Null; imgGlare = Null; imgPlay = Null; imgRing = Null; imgSkull = Null
imgCups = Null; imgFont = Null; imgEnd = Null

SetMaskColor 255, 0, 255
If Filter = 0 Then Flags = MASKEDIMAGE Else Flags = MASKEDIMAGE|FILTEREDIMAGE|MIPMAPPEDIMAGE
imgTitle = LoadImage("gfx/title.png", Flags)
imgGlare = LoadAnimImage("gfx/glare.png", 7, 7, 0, 3, Flags); MidHandleImage imgGlare
imgPlay = LoadImage("gfx/play.png", Flags)
imgRing = LoadImage("gfx/ring.png", Flags)
imgSkull = LoadImage("gfx/skull.png", Flags); MidHandleImage imgSkull
imgCups = LoadImage("gfx/cups.png", Flags)
imgFont = LoadAnimImage("gfx/font.png", 7, 8, 0, 11, Flags)
imgEnd = LoadImage("gfx/end.png", Flags)

End Function

Function RenderTitle()

SetScale 2, 2
DrawImage imgTitle, 0, 0
For o:Obj = EachIn objList; o.Render; Next
SetScale 1, 1

If RandRange(1, 100) = 50 Then
    Repeat
        tmpPos = RandRange(1, 6)
        
        tmpFail = False
        For o:Obj = EachIn ObjList
            If o.ID = 1 And o.R = tmpPos Then tmpFail = True; Exit
        Next    
    Until tmpFail = False
    
    Select tmpPos
        Case 1
        tmpX = 100; tmpY = 198
        
        Case 2
        tmpX = 45; tmpY = 198
        
        Case 3
        tmpX = 80; tmpY = 164
        
        Case 4
        tmpX = 139; tmpY = 140
        
        Case 5
        tmpX = 100; tmpY = 84
        
        Case 6
        tmpX = 28; tmpY = 91
    
    End Select
    
    tmpX:*2; tmpY:*2
    objList.AddLast obj.Create(tmpX, tmpY, tmpPos, 1)
EndIf

If KeyHit(KEY_SPACE) Then 
    If ChannelPlaying(Channel) = True Then 
        StopChannel Channel
        Channel = PlaySound(musSong1)
    EndIf

    For o:Obj = EachIn ObjList; objList.Remove o; Next
    
    FlushKeys
    bTitle = False
EndIf

End Function

Function WindowMode()

    tmpClass$ = "BBDX7Device Window Class"
	Local hWnd% = FindWindow(tmpClass$, "Ironsword: Skull and Bones")

	Local desk_hWnd% = GetDesktopWindow(), l:lpRect = New lpRECT
	GetWindowRect desk_hWnd, l:lpRECT 

	SetWindowPos hWnd, -2, (l.r / 2) - (640 / 2), (l.b / 2) - (480 / 2), 0, 0, 1
	l:lpRECT = Null
	
	Local tmp:Long = GetWindowLongA( hWnd, GWL_STYLE )
	tmp = tmp | WS_MINIMIZEBOX
	SetWindowLongA hWnd, GWL_STYLE, tmp
	DrawMenuBar hWnd
	
	tmp = GetWindowLongA( hWnd, GWL_STYLE )
	tmp = tmp | WS_MAXIMIZEBOX
	SetWindowLongA  hWnd, GWL_STYLE, tmp 
	DrawMenuBar hWnd 
	
	myhWnd = hWnd
End Function

Function HandleMouse()

Select PollEvent()
	Case EVENT_MOUSELEAVE
    ShowMouse
    
	Case EVENT_MOUSEENTER
    HideMouse

End Select

End Function

Function HandleVideo()

If iszoomed(myhWnd) Then
	EndGraphics
	Graphics 640, 480, 32, 60
	vidMode = 1
EndIf

If KeyHit(KEY_ESCAPE) Then
    If vidMode = 1 Then
        EndGraphics
        Graphics 640, 480, 0, 60
        WindowMode 
        vidMode = 2
        FlushKeys

    Else
        If bTitle = False And gameOver = False Then
            If ChannelPlaying(Channel) = True Then 
                StopChannel Channel
                Channel = PlaySound(musSong2)
            EndIf

			For o:Obj = EachIn ObjList; objList.Remove o; Next
            gameOver = True

        ElseIf gameOver = True Then
            If ChannelPlaying(Channel) = True Then 
                StopChannel Channel
                Channel = PlaySound(musTitle)
            EndIf
            
            score = 1000; bSkull = False; correct = 0; wrong = 0 ' Reset
            ringX = 40; ringC = 0
            
            gameOver = False; bTitle = True  
			For o:Obj = EachIn ObjList; objList.Remove o; Next          
			
        ElseIf bTitle = True
            StopChannel Channel
            End

        EndIf
    EndIf
    
    FlushKeys
EndIf

If KeyHit(KEY_SPACE) And gameOver = True Then
    If ChannelPlaying(Channel) = True Then 
        StopChannel Channel
        Channel = PlaySound(musTitle)
    EndIf
    
    score = 1000; bSkull = False; correct = 0; wrong = 0 ' Reset
    ringX = 40; ringC = 0
    
    gameOver = False; bTitle = True
    For o:Obj = EachIn ObjList; objList.Remove o; Next

    FlushKeys
EndIf

If KeyHit(KEY_F1) Then
    If bFilter = 0 Then bFilter = 1 Else bFilter = 0
    LoadImages bFilter
    
    FlushKeys
EndIf
    
End Function

Function MilliSecs()
	If LastMilliSecs = 0 Then LastMilliSecs = GetTickCount() ' Check
	
	If GetTickCount() > LastMilliSecs Then MyMilliSecs = MyMilliSecs + (GetTickCount() - LastMilliSecs)
	If GetTickCount() < LastMilliSecs Then MyMilliSecs = MyMilliSecs + (LastMilliSecs - GetTickCount())

	LastMilliSecs = GetTickCount()
	Return MyMilliSecs
    
End Function

Function bmpText(txt$, x, y)

tmpX = X
For i = 1 To Len(txt$)
	tmpAsc = Asc(Mid(txt$, i, 1))
	If tmpAsc = 37 Then tmpF = 10 Else tmpF = tmpAsc - 48
    DrawImage imgFont, tmpX, y, tmpF
    tmpX:+16
Next

End Function
